<script lang="ts" setup>
import { ChevronLgRight } from 'slippers-ui/icons';
import { useI18n } from 'vue-i18n';
const { t } = useI18n();

interface TeamHeadshotBlockProps {
  header: string;
  cards: Array<{
    title: string;
    subtitle?: string;
    description: string;
    image: {
      config: {
        src: string;
      };
    };
  }>;
  buttons: Array<{
    text: string;
    config: {
      href: string;
      dataGaName: string;
      dataGaLocation: string;
    };
  }>;
}

defineProps<TeamHeadshotBlockProps>();

const isModalOpen = ref(false);
const modalInfo = ref({});

const openModal = (info: object) => {
  isModalOpen.value = true;
  modalInfo.value = info;
};

const closeModal = () => {
  isModalOpen.value = false;
};
</script>

<template>
  <SlpSection background-color="$color-surface-800" class="block">
    <div class="block__gradient-header slp-mt-48" />
    <SlpRow class="slp-mb-md-96 slp-mb-48">
      <SlpTypography tag="h1" variant="heading2-bold">
        {{ header }}
      </SlpTypography>
    </SlpRow>
    <SlpRow class="grid">
      <SlpColumn v-for="headshot in cards" :key="headshot.title" class="slp-mb-64 block__wrapper" :cols="6" size="lg">
        <div class="block__headshot" @click="openModal(headshot)">
          <img class="block__headshot__image" :src="headshot.image.config.src" :alt="`Photo of ${headshot.title}`" />
          <div class="block__headshot-body">
            <SlpTypography class="slp-mb-32" tag="h4" variant="heading4-bold">
              {{ headshot.title }}
            </SlpTypography>
            <SlpTypography v-if="headshot.subtitle" tag="p" variant="body1">
              {{ headshot.subtitle }}
            </SlpTypography>
            <SlpButton
              class="slp-mt-24"
              variant="tertiary"
              data-ga-location="body"
              :data-ga-name="headshot.title.toLowerCase()"
              @click="openModal(headshot)"
            >
              {{ t('commonCtas.learnMore') }}
              <SlpIcon :icon="ChevronLgRight" />
            </SlpButton>
          </div>
        </div>
      </SlpColumn>
    </SlpRow>
    <SlpRow v-for="button in buttons" :key="button.text" class="block__more-links">
      <SlpButton
        :data-ga-location="button.config.dataGaLocation"
        :data-ga-name="button.config.dataGaName"
        :href="button.config.href"
        class="slp-my-48"
        variant="tertiary"
      >
        {{ button.text }}
        <SlpIcon :icon="ChevronLgRight" variant="product" />
      </SlpButton>
    </SlpRow>
    <Teleport to="body">
      <CommonContentModal v-if="isModalOpen" class="board__modal" @close="closeModal">
        <div class="block__modal-content">
          <SlpTypography tag="h3" variant="heading3-bold">
            {{ modalInfo.title }}
          </SlpTypography>
          <div class="block__modal-story" v-html="$md.render(modalInfo.description)"></div>
        </div>
      </CommonContentModal>
    </Teleport>
  </SlpSection>
</template>

<style lang="scss" scoped>
.block {
  &__wrapper {
    flex: 1;

    @media (max-width: $breakpoint-md) {
      flex: 0 0 49%;
      width: 49%;
    }

    @media (max-width: $breakpoint-sm) {
      flex: 1 0 100%;
      width: 100%;
    }
  }

  .grid {
    @media (max-width: $breakpoint-md) {
      justify-content: space-between;
    }
  }

  &__gradient-header {
    background: linear-gradient(90deg, #ffc8c6 0%, #b3bded 100%);
    height: 4px;
    width: 95px;
    border-radius: 10px;
    margin-bottom: $spacing-16;
  }

  &__headshot {
    height: 100%;
    background: $color-primary-300;
    border-radius: 20px;
    display: flex;
    flex-direction: column;
    position: relative;

    @media (min-width: $breakpoint-md) {
      &:nth-child(even) {
        margin-left: $spacing-48;
      }

      &:nth-child(odd) {
        margin-right: $spacing-48;
      }
    }

    &__image {
      object-fit: cover;
      object-position: top;
      max-height: 240px;
      height: 240px;

      @media (min-width: $breakpoint-md) {
        position: absolute;
        top: -32px;
        left: -20px;
        max-width: 220px;
        width: 220px;
        border-bottom-right-radius: 100px;
      }

      @media (max-width: $breakpoint-md) {
        max-height: 100%;
        height: 100%;
      }
    }

    &:hover {
      cursor: pointer;
    }
  }

  &__headshot-body {
    padding: $spacing-32;
    min-height: 250px;

    @media (min-width: $breakpoint-md) {
      padding-left: 250px;
    }
  }

  &__more-links {
    justify-content: center;
  }

  &__modal-story:deep(p) {
    padding-top: 20px;
  }

  &__modal-content {
    max-width: 800px;
    padding: 0 32px 32px 32px;

    &:deep(p) {
      padding-top: 20px;
    }

    &:deep(h5) {
      font-size: 20px;
      padding-top: 20px;
      font-weight: 600;
      line-height: 24px;
    }

    &:deep(.header-anchor) {
      display: none;
      width: 0;
      height: 0;
    }

    @media (max-width: $breakpoint-md) {
      max-height: 90vh;
      overflow-y: auto;
    }
  }
}
</style>
